unit AppStyleU;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs, QMenus,
  QTypes, QStdActns, QActnList, QStdCtrls;

type
  TForm1 = class(TForm)
    ActionList1: TActionList;
    MainMenu1: TMainMenu;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditDelete1: TEditDelete;
    HelpContents1: THelpContents;
    HelpTopicSearch1: THelpTopicSearch;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Help1: TMenuItem;
    HelpContents11: TMenuItem;
    HelpTopicSearch11: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    N1: TMenuItem;
    SelectAll1: TMenuItem;
    Exit1: TMenuItem;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    ListBox1: TListBox;
    ComboBox1: TComboBox;
    Style1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure StyleMenuClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

uses
  TypInfo, QStyle;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Style: TDefaultStyle;
  StyleName: String;
  Menu: TMenuItem;
begin
  for Style := Low(TDefaultStyle) to High (TDefaultStyle) do
  begin
    //Turn the current TDefaultStyle value into a string
    StyleName := GetEnumName(TypeInfo(TDefaultStyle), Ord(Style));
    Menu := NewItem(StyleName, 0, False, True, StyleMenuClick, 0, '');
    //NewItem makes un-owned components. This rectifies that
    InsertComponent(Menu);
    Menu.GroupIndex := 1;
    Menu.RadioItem := True;
    //Make sure the current style is indicated
    if Style = Application.Style.DefaultStyle then
      Menu.Checked := True;
    Style1.Add(Menu);
  end
end;

procedure TForm1.StyleMenuClick(Sender: TObject);
var
  Menu: TMenuItem;
  NewStyle: TDefaultStyle;
begin
  Menu := Sender as TMenuItem;
  //Take the menu item's caption, remove any &'s, and turn the
  //resultant string into the corresponding TDefaultStyle value
  NewStyle := TDefaultStyle(
    GetEnumValue(TypeInfo(TDefaultStyle), StripHotkey(Menu.Caption)));
  Application.Style.DefaultStyle := NewStyle;
  Menu.Checked := True;
end;

end.
