unit ButtonEx2;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls;

type
  TMessageEvent = procedure(Sender: TComponent; var Msg: TMessage) of object;

  TButtonEx2 = class(TButton)
  private
    FOnClickNotification: TNotifyEvent;
    FOnMessage: TMessageEvent;
  protected
    procedure WndProc(var Message: TMessage); override;
  published
    property OnClickNotification: TNotifyEvent read FOnClickNotification write FOnClickNotification;
    property OnMessage: TMessageEvent read FOnMessage write FOnMessage;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TButtonEx2]);
end;

{ TButtonEx2 }

procedure TButtonEx2.WndProc(var Message: TMessage);
begin
  if Assigned(OnMessage) then
    OnMessage(Self, Message);
  if (Message.Msg = CN_COMMAND) and (Message.WParamHi = BN_CLICKED) and
     Assigned(OnClickNotification) then
    OnClickNotification(Self);
  //Do not call inherited window proc if you want to hide the message
  inherited;
end;

end.
