unit WindowProcHookU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Lst: TListView;
    Panel1: TPanel;
    chkWndProcHooked: TCheckBox;
    Button1: TButton;
    procedure chkWndProcHookedClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FOldBtnWndProc: TWndMethod;
    procedure NewBtnWndProc(var Message: TMessage);
  public
    procedure SetNewBtnWndProc(Enable: Boolean);
  end;

var
  Form1: TForm1;

implementation

uses MessageIDs;

{$R *.dfm}

procedure TForm1.chkWndProcHookedClick(Sender: TObject);
begin
  SetNewBtnWndProc(chkWndProcHooked.Checked)
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SetNewBtnWndProc(False);
end;

procedure TForm1.SetNewBtnWndProc(Enable: Boolean);
begin
  if Enable then
  begin
    FOldBtnWndProc := Button1.WindowProc;
    Button1.WindowProc := NewBtnWndProc;
  end
  else
    if @FOldBtnWndProc <> nil then
    begin
      Button1.WindowProc := FOldBtnWndProc;
      FOldBtnWndProc := nil;
    end;
end;

procedure TForm1.NewBtnWndProc(var Message: TMessage);
var
  Item: TListItem;
begin
  //Make new list view item
  Item := Lst.Items.Add;
  //Set up new list view item with message description
  Item.Caption := MsgIDToStr(Message.Msg);
  Item.SubItems.Add(Format('$%x (%0:d)', [Message.WParam]));
  Item.SubItems.Add(Format('$%x (%0:d)', [Message.LParam]));
  Item.SubItems.Add(FormatDateTime('h:nn:ss.zzz', Time));
  Item.Selected := True;
  Item.Focused := True;
  Item.MakeVisible(False);

  //Do not call the original window procedure if you want to hide this message
  FOldBtnWndProc(Message);
end;
    
end.
